
import java.util.HashMap;
import java.util.Map;

import net.ponder2.objects.P2Object;
import net.ponder2.exception.Ponder2OperationException;
import net.ponder2.exception.Ponder2Exception;
import net.ponder2.ManagedObject;

/**
 * Adaptor object for managed object
 * 
 * @author Auto generated by annotation processor tool
 */
public class SampleObjectP2Adaptor extends net.ponder2.P2ObjectAdaptor {

  /**
   * The map of create operations to constructors
   */
  private final static Map<String, CreateOperation> create;
  /**
   * The map of instance operations to methods
   */
  private final static Map<String, InstanceOperation> operation;

  // Create the call tables when the class is loaded
  static {
    create = new HashMap<String, CreateOperation>();
    operation = new HashMap<String, InstanceOperation>();

    // Create operation 'create' calls constructor for SampleObject
    create.put("create", new CreateOperation() {
      @Override
      public net.ponder2.ManagedObject call(P2Object obj, P2Object source, String operation, P2Object... args)
          throws net.ponder2.exception.Ponder2Exception {
        return new SampleObject();
      }
    });

    // Create operation 'size:' calls constructor for SampleObject
    create.put("size:", new CreateOperation() {
      @Override
      public net.ponder2.ManagedObject call(P2Object obj, P2Object source, String operation, P2Object... args)
          throws net.ponder2.exception.Ponder2Exception {
        return new SampleObject(args[0].asInteger());
      }
    });

    // Operation 'at:put:' calls p2_operation_at_put
    operation.put("at:put:", new InstanceOperation() {
      @Override
      public P2Object call(P2Object thisObj, net.ponder2.ManagedObject obj, P2Object source, String operation, P2Object... args)
          throws net.ponder2.exception.Ponder2Exception {
        net.ponder2.objects.P2Object value = 
             ((SampleObject)obj).p2_operation_at_put(args[0].asString(), args[1]);
        return value;
      }
    });

    // Operation 'at:' calls p2_operation_at
    operation.put("at:", new InstanceOperation() {
      @Override
      public P2Object call(P2Object thisObj, net.ponder2.ManagedObject obj, P2Object source, String operation, P2Object... args)
          throws net.ponder2.exception.Ponder2Exception {
        net.ponder2.objects.P2Object value = 
             ((SampleObject)obj).p2_operation_at(args[0].asString());
        return value;
      }
    });

    // Operation 'remove' calls p2_operation_remove
    operation.put("remove", new InstanceOperation() {
      @Override
      public P2Object call(P2Object thisObj, net.ponder2.ManagedObject obj, P2Object source, String operation, P2Object... args)
          throws net.ponder2.exception.Ponder2Exception {
        net.ponder2.objects.P2Object value = 
             ((SampleObject)obj).p2_operation_remove(args[0].asString());
        return value;
      }
    });

    // Operation 'size' calls p2_operation_size
    operation.put("size", new InstanceOperation() {
      @Override
      public P2Object call(P2Object thisObj, net.ponder2.ManagedObject obj, P2Object source, String operation, P2Object... args)
          throws net.ponder2.exception.Ponder2Exception {
        int value = 
             ((SampleObject)obj).p2_operation_size();
        return P2Object.create(value);
      }
    });
  }

  public SampleObjectP2Adaptor() {
  }

  public SampleObjectP2Adaptor(P2Object source, String operation, P2Object... args)
      throws Ponder2Exception {
     super(source, operation, args);
  }


  @Override
  public CreateOperation getCreateOperation(String opName) throws net.ponder2.exception.Ponder2OperationException {
    CreateOperation op = create.get(opName);
    return op != null ? op : super.getCreateOperation(opName);
  }

  @Override
  public InstanceOperation getInstanceOperation(String opName) throws net.ponder2.exception.Ponder2OperationException {
    InstanceOperation op = operation.get(opName);
    return op != null ? op : super.getInstanceOperation(opName);
  }

}

