package net.ponder2.managedobject;

import java.util.HashMap;
import java.util.Map;

import net.ponder2.objects.P2Object;
import net.ponder2.exception.Ponder2OperationException;
import net.ponder2.exception.Ponder2Exception;
import net.ponder2.ManagedObject;

/**
 * Adaptor object for managed object
 * 
 * @author Auto generated by annotation processor tool
 */
public class DiscoveryManagerP2Adaptor extends net.ponder2.P2ObjectAdaptor {

  /**
   * The map of create operations to constructors
   */
  private final static Map<String, CreateOperation> create;
  /**
   * The map of instance operations to methods
   */
  private final static Map<String, InstanceOperation> operation;

  // Create the call tables when the class is loaded
  static {
    create = new HashMap<String, CreateOperation>();
    operation = new HashMap<String, InstanceOperation>();

    // Create operation 'create:' calls constructor for DiscoveryManager
    create.put("create:", new CreateOperation() {
      @Override
      public net.ponder2.ManagedObject call(P2Object obj, P2Object source, String operation, P2Object... args)
          throws net.ponder2.exception.Ponder2Exception {
        return new DiscoveryManager(obj, args[0].asString());
      }
    });

    // Operation 'newPump:' calls newPump
    operation.put("newPump:", new InstanceOperation() {
      @Override
      public P2Object call(P2Object thisObj, net.ponder2.ManagedObject obj, P2Object source, String operation, P2Object... args)
          throws net.ponder2.exception.Ponder2Exception {
             ((DiscoveryManager)obj).newPump(args[0]);
        return thisObj;
      }
    });

    // Operation 'lostPump:' calls lostPump
    operation.put("lostPump:", new InstanceOperation() {
      @Override
      public P2Object call(P2Object thisObj, net.ponder2.ManagedObject obj, P2Object source, String operation, P2Object... args)
          throws net.ponder2.exception.Ponder2Exception {
             ((DiscoveryManager)obj).lostPump(args[0]);
        return thisObj;
      }
    });

    // Operation 'newBSN:' calls newBsnEvent
    operation.put("newBSN:", new InstanceOperation() {
      @Override
      public P2Object call(P2Object thisObj, net.ponder2.ManagedObject obj, P2Object source, String operation, P2Object... args)
          throws net.ponder2.exception.Ponder2Exception {
             ((DiscoveryManager)obj).newBsnEvent(args[0]);
        return thisObj;
      }
    });

    // Operation 'lostBSN:' calls lostBsnEvent
    operation.put("lostBSN:", new InstanceOperation() {
      @Override
      public P2Object call(P2Object thisObj, net.ponder2.ManagedObject obj, P2Object source, String operation, P2Object... args)
          throws net.ponder2.exception.Ponder2Exception {
             ((DiscoveryManager)obj).lostBsnEvent(args[0]);
        return thisObj;
      }
    });

    // Operation 'bsnValue:' calls bsnValue
    operation.put("bsnValue:", new InstanceOperation() {
      @Override
      public P2Object call(P2Object thisObj, net.ponder2.ManagedObject obj, P2Object source, String operation, P2Object... args)
          throws net.ponder2.exception.Ponder2Exception {
             ((DiscoveryManager)obj).bsnValue(args[0]);
        return thisObj;
      }
    });

    // Operation 'filter:' calls bsnFilter
    operation.put("filter:", new InstanceOperation() {
      @Override
      public P2Object call(P2Object thisObj, net.ponder2.ManagedObject obj, P2Object source, String operation, P2Object... args)
          throws net.ponder2.exception.Ponder2Exception {
             ((DiscoveryManager)obj).bsnFilter(args[0].asBoolean());
        return thisObj;
      }
    });
  }

  public DiscoveryManagerP2Adaptor() {
  }

  public DiscoveryManagerP2Adaptor(P2Object source, String operation, P2Object... args)
      throws Ponder2Exception {
     super(source, operation, args);
  }


  @Override
  public CreateOperation getCreateOperation(String opName) throws net.ponder2.exception.Ponder2OperationException {
    CreateOperation op = create.get(opName);
    return op != null ? op : super.getCreateOperation(opName);
  }

  @Override
  public InstanceOperation getInstanceOperation(String opName) throws net.ponder2.exception.Ponder2OperationException {
    InstanceOperation op = operation.get(opName);
    return op != null ? op : super.getInstanceOperation(opName);
  }

}

