/**
 * Created on Sep 14, 2005
 * Copyright  2005 Imperial College, London, England.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Contact: Kevin Twidle <kpt@doc.ic.ac.uk>
 *
 * $Log: AlarmWindow.java,v $
 * Revision 1.2  2005/10/24 20:53:02  kpt
 * Dump part of dump and restore working
 *
 * Revision 1.1  2005/09/14 21:01:27  kpt
 * BedStation example added
 *
 */

package net.ponder2.tutorial;

import java.awt.BorderLayout;
import java.awt.Color;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;

public class AlarmWindow extends JFrame {

  ImageIcon alarmon, alarmoff;
  JLabel label;

  public AlarmWindow() {

    getContentPane().setLayout(new BorderLayout());
    getContentPane().setBackground(Color.WHITE);

    // Create icon
    alarmon = new ImageIcon(this.getClass().getResource("alarm_clock-on.gif"));
    alarmoff = new ImageIcon(this.getClass().getResource("alarm_clock-off.gif"));
    label = new JLabel();
    setAlarm(false);

    // Add the component to the frame's content pane;
    // by default, the content pane has a border layout
    getContentPane().add(label, BorderLayout.CENTER);

    // Adjust the frame size
    int width = alarmoff.getIconWidth();
    int height = alarmoff.getIconHeight();
    setSize(width, height+30);
    
  }

  public void setAlarm(boolean on) {
    label.setIcon(on ? alarmon : alarmoff);
  }
  
  public boolean isAlarm() {
    return label.getIcon() == alarmon;
  }
}
